-- This Source Code Form is subject to the terms of the Mozilla Public
-- License, v. 2.0. If a copy of the MPL was not distributed with this file,
-- You can obtain one at http://mozilla.org/MPL/2.0/.


local VERSION = "8.0.1"
local BAGS_WIDTH = (4*42+42)
local leftEndWidth = MainMenuBarArtFrame.LeftEndCap:GetWidth();
local zleftEndOffset = 0;
local zrightEndOffset = 0;
local zmbOffset = 0;
local zmbScale = 30;
local zmbgScale = 0;
local zmbgOffset = 0;
local zxpBarOffset = 0;
local zactBarOffset = 0;
local zisDouble = false;
local zbar = nill;
local zbarWidth = 0;
local zbarScale = 0;
local zbabScale = 1.1;
local zbabVOffset = 0;


-- start moved block
	-- create options pane
local f = CreateFrame("Frame",nil,UIParent);
f:SetFrameStrata("BACKGROUND");
f:SetWidth(500); -- Set these to whatever height/width is needed 
f:SetHeight(600); -- for your Texture

f:SetPoint("TOP",0,-50)
f:SetBackdrop({
	bgFile="Interface\\ChatFrame\\ChatFrameBackground",
	edgeFile="Interface\\ChatFrame\\ChatFrameBackground",
	tile=true,
	tileSize=5,
	edgeSize= 2,
});
f:SetBackdropColor(0,0,0,0.7);
f:SetBackdropBorderColor(0,0,0,1);
f:Hide();
f.Label = f:CreateFontString(nil , "BORDER", "GameFontNormal", 40);

f.Label:SetPoint("TOP", f, "TOP", 0, -5);
f.Label:SetText("OdiousRetroUI Config");

function f:OnEvent(event, arg1)
	if event == "ADDON_LOADED" then
		if leftEndOffset == nil then
			zleftEndOffset = 0; -- This is the first time this addon is loaded; initialize the count to 0.
		else
			zleftEndOffset = leftEndOffset;
		end

		if rightEndOffset == nil then
			zrightEndOffset = 0; -- This is the first time this addon is loaded; initialize the count to 0.
		else
			zrightEndOffset = rightEndOffset;
		end

		if mbOffset == nill then
			zmbOffset = 0;
		else
			zmbOffset = mbOffset;
		end
		
		if babScale == nill then
			zbabScale = 1.1;
		else
			zbabScale = babScale;
		end

		if mbgOffset == nill then
			zmbgOffset = 0;
		else
			zmbgOffset = mbgOffset;
		end

		if mbScale == nill then
			zmbScale = 30;
		else
			zmbScale = mbScale;
		end
		
				if mbgScale == nill then
			zmbgScale = 30;
		else
			zmbgScale = mbgScale;
		end

		if barScale == nill then
			zbarScale = 0;
		else
			zbarScale = barScale;
		end

		if xpBarOffset == nill then
			zxpBarOffset = 0;
		else
			zxpBarOffset = xpBarOffset;
		end

		if actBarOffset == nill then
			zactBarOffset = 0;
		else
			zactBarOffset = actBarOffset;
		end
		
		if babVOffset == nill then
			zbabVOffset = 0;
		else
			zbabVOffset= babVOffset;
		end
		
		if forceUI == nill then 
			forceUI = false
		end
	end



local zxpBarOffset = 0
local zactBarOffset = 0
	if event == "PLAYER_REGEN_ENABLED" then
		if not forceUI then
			-- Reposition MainMenuBarArtFrame and use it as the anchor instead of MainMenuBar where possible
			-- this is the primary action bar
			MainMenuBarArtFrameBackground:ClearAllPoints();
			MainMenuBarArtFrameBackground:SetPoint("BOTTOM", UIParent, "BOTTOM", -BAGS_WIDTH+(MainMenuBarArtFrame.LeftEndCap:GetWidth()/3)+zactBarOffset, 1);

			-- Move left and right dragons further to make some room
			MainMenuBarArtFrame.LeftEndCap:ClearAllPoints();
			MainMenuBarArtFrame.RightEndCap:ClearAllPoints();
			MainMenuBarArtFrame.LeftEndCap:SetPoint("BOTTOMRIGHT", MainMenuBarArtFrame, "BOTTOMLEFT", MainMenuBarArtFrame.LeftEndCap:GetWidth()*-1+zleftEndOffset, -10);
			MainMenuBarArtFrame.RightEndCap:SetPoint("BOTTOMLEFT", MainMenuBarArtFrame, "BOTTOMRIGHT", MainMenuBarArtFrame.LeftEndCap:GetWidth()+zrightEndOffset, -10);

			zbar:SetPoint("BOTTOMLEFT", ActionButton1, "TOPLEFT", 0, 0);

			if ( zisDouble ) then
				StatusTrackingBarManager:SetDoubleBarSize(zbar, zbarWidth + BAGS_WIDTH + leftEndWidth + zbarScale);
			else 
				StatusTrackingBarManager:SetSingleBarSize(zbar, zbarWidth + BAGS_WIDTH + leftEndWidth + zbarScale);
	   	        end
		end

	end

	if event == "PLAYER_REGEN_DISABLED" then
		f:Hide();
	end

	if event == "PLAYER_XP_UPDATE" then
		if InCombatLockdown() then return end
	end

	if event == "PLAYER_ENTERING_WORLD" then
	setUI()
	end
end

f:RegisterEvent("ADDON_LOADED");
f:RegisterEvent("PLAYER_REGEN_ENABLED");
f:RegisterEvent("PLAYER_REGEN_DISABLED");
f:RegisterEvent("PLAYER_XP_UPDATE");
f:RegisterEvent("PLAYER_ENTERING_WORLD");


f:SetScript("OnEvent", f.OnEvent);
		
-- end moved block

-- Create new textures for bags and microbuttons backdrop
-- MOVES MICROBUTTONS
MainMenuBarArtFrameBackground.MicroButtonArt = MainMenuBarArtFrameBackground:CreateTexture();
MainMenuBarArtFrameBackground.MicroButtonArt:SetSize(BAGS_WIDTH*2+zmbgScale, 44);
MainMenuBarArtFrameBackground.MicroButtonArt:SetPoint("BOTTOMRIGHT", MainMenuBarArtFrame, "BOTTOMRIGHT", 0+zmbgOffset, -10);
MainMenuBarArtFrameBackground.MicroButtonArt:SetTexture(MicroButtonAndBagsBar.MicroBagBar:GetTexture());
MainMenuBarArtFrameBackground.MicroButtonArt:SetTexCoord(245/1024, 542/1024, 212/256, 255/256);

-- MOVES BAG ART BACKGROUND
MainMenuBarArtFrameBackground.MultiBagsArt = MainMenuBarArtFrameBackground:CreateTexture();
MainMenuBarArtFrameBackground.MultiBagsArt:SetSize(BAGS_WIDTH - 40, 46);
MainMenuBarArtFrameBackground.MultiBagsArt:SetPoint("BOTTOMRIGHT", MainMenuBarArtFrame.RightEndCap, "BOTTOMLEFT", -MainMenuBarArtFrame.RightEndCap:GetWidth()/10, 0);
MainMenuBarArtFrameBackground.MultiBagsArt:SetTexture(MicroButtonAndBagsBar.MicroBagBar:GetTexture());
MainMenuBarArtFrameBackground.MultiBagsArt:SetTexCoord(365/1024, 495/1024, 177/256, 211/256);

MainMenuBarArtFrameBackground.MainBagsArt = MainMenuBarArtFrameBackground:CreateTexture();
MainMenuBarArtFrameBackground.MainBagsArt:SetSize(44, 46);
MainMenuBarArtFrameBackground.MainBagsArt:SetPoint("TOPLEFT", MainMenuBarArtFrameBackground.MultiBagsArt, "TOPRIGHT", 0, 0);
MainMenuBarArtFrameBackground.MainBagsArt:SetTexture(MicroButtonAndBagsBar.MicroBagBar:GetTexture());
MainMenuBarArtFrameBackground.MainBagsArt:SetTexCoord(495/1024, 539/1024, 168/256, 211/256);



-- Enlarge status bars to include bags and microbuttons
-- and move them between the 2 rows of buttons, as it should
hooksecurefunc(StatusTrackingBarManager, "LayoutBar", function (self, bar, barWidth, isTopBar, isDouble)
	if InCombatLockdown() and not forceUI then return end
	zbar = bar;
	zbarWidth = barWidth;
	bar:ClearAllPoints();
	if ( isDouble ) then
		zisDouble = isDouble
		if ( isTopBar ) then
		bar:SetPoint("BOTTOMLEFT", ActionButton1, "TOPLEFT", 0, 10);
		else		
		bar:SetPoint("BOTTOMLEFT", ActionButton1, "TOPLEFT", 0, 0);
		end
		self:SetDoubleBarSize(bar, barWidth + BAGS_WIDTH + leftEndWidth + zbarScale);
	else
		bar:SetPoint("BOTTOMLEFT", ActionButton1, "TOPLEFT", 0, 0);
		self:SetSingleBarSize(bar, barWidth + BAGS_WIDTH + leftEndWidth + zbarScale);
    end
end);

-- Move back the bags and micro buttons inside the main UI
hooksecurefunc(MainMenuBar, "SetPositionForStatusBars", function ()
    
    -- avoid taint
    if InCombatLockdown() and not forceUI then return end
	
	
	-- Reposition MainMenuBarArtFrame and use it as the anchor instead of MainMenuBar where possible
    -- this is the primary action bar
    MainMenuBarArtFrameBackground:ClearAllPoints();
    MainMenuBarArtFrameBackground:SetPoint("BOTTOM", UIParent, "BOTTOM", -BAGS_WIDTH+(MainMenuBarArtFrame.LeftEndCap:GetWidth()/3)+zactBarOffset, 1);

    -- Move left and right dragons further to make some room
	MainMenuBarArtFrame.LeftEndCap:ClearAllPoints();
	MainMenuBarArtFrame.RightEndCap:ClearAllPoints();
	MainMenuBarArtFrame.LeftEndCap:SetPoint("BOTTOMRIGHT", MainMenuBarArtFrame, "BOTTOMLEFT", MainMenuBarArtFrame.LeftEndCap:GetWidth()*-1+zleftEndOffset, -10);
        MainMenuBarArtFrame.RightEndCap:SetPoint("BOTTOMLEFT", MainMenuBarArtFrame, "BOTTOMRIGHT", MainMenuBarArtFrame.LeftEndCap:GetWidth()+zrightEndOffset, -10);
		
		-- avoid taint
    if InCombatLockdown() and forceUI then return end


    MainMenuBarArtFrame:ClearAllPoints();
    if ( StatusTrackingBarManager:GetNumberVisibleBars() == 2 ) then 
        MainMenuBarArtFrame:SetPoint("TOPLEFT", MainMenuBar, 0, 10 - 17);
        MainMenuBarArtFrame:SetPoint("BOTTOMRIGHT", MainMenuBar, 0, 10 - 17);
	elseif ( StatusTrackingBarManager:GetNumberVisibleBars() == 1 ) then
        MainMenuBarArtFrame:SetPoint("TOPLEFT", MainMenuBar, 0, 10 - 14);
        MainMenuBarArtFrame:SetPoint("BOTTOMRIGHT", MainMenuBar, 0, 10 - 14);
	else 
        MainMenuBarArtFrame:SetPoint("TOPLEFT", MainMenuBar, 0, 10);
        MainMenuBarArtFrame:SetPoint("BOTTOMRIGHT", MainMenuBar, 0, 10);
	end

    -- Move the bags buttons
    MainMenuBarBackpackButton:SetParent(MainMenuBarArtFrame);
    MainMenuBarBackpackButton:ClearAllPoints();
    MainMenuBarBackpackButton:SetPoint("BOTTOMRIGHT", MainMenuBarArtFrame.RightEndCap, "BOTTOMLEFT", -MainMenuBarArtFrame.RightEndCap:GetWidth()/10+40, 00);
    
    for i = 0,3 do
        _G["CharacterBag"..i.."Slot"]:SetParent(MainMenuBarArtFrame);
        _G["CharacterBag"..i.."Slot"]:SetSize(40, 40);
        _G["CharacterBag"..i.."Slot"].IconBorder:SetSize(42, 42);
    end
    CharacterBag0Slot:ClearAllPoints();
    CharacterBag0Slot:SetPoint("RIGHT", MainMenuBarBackpackButton, "LEFT", 0, 0);

    -- Move the microbuttons
    MicroButtonAndBagsBar:Hide();
    FloRetroUI_MainMenuBar_OnShow();

    -- Move the aditional action bars above status bar
    if ( IsPlayerInWorld() ) then

        -- Don't let UIParent_ManageFramePositions manage the MultiBarBottomLeft
        UIPARENT_MANAGED_FRAME_POSITIONS["MultiBarBottomLeft"] = nil;
        UIPARENT_MANAGED_FRAME_POSITIONS["MultiBarBottomRight"] = nil;
        MultiBarBottomLeft:ClearAllPoints();
	MultiBarBottomLeft:SetScale(zbabScale, 1.0);
	MultiBarBottomRight:SetScale(zbabScale, 1.0);

        MultiBarBottomRightButton7:ClearAllPoints();
        MultiBarBottomRightButton1:ClearAllPoints();

        MultiBarBottomLeft:SetPoint("BOTTOMLEFT", ActionButton1, "TOPLEFT", 0, 30+zbabVOffset);
		MultiBarBottomRightButton1:SetPoint("TOPLEFT", MultiBarBottomLeftButton12, "TOPRIGHT", 10, 0);
		MultiBarBottomRightButton7:SetPoint("TOPLEFT", MultiBarBottomRightButton6, "TOPLEFT", 42, 0);
    end
end);

-- Move the microbuttons
function FloRetroUI_MainMenuBar_OnShow()

    if InCombatLockdown() then return end

    if OverrideActionBar:IsVisible() then
        MainMenuBarPerformanceBar:SetSize(zmbScale, 40);
        for i=1, #MICRO_BUTTONS do
            _G[MICRO_BUTTONS[i]]:SetSize(zmbScale, 36);
            _G[MICRO_BUTTONS[i].."Flash"]:SetSize(zmbScale+5, 40);
            if i ~= 1 and MICRO_BUTTONS[i] ~= "LFDMicroButton" then
                local relativeTo;
                _, relativeTo = _G[MICRO_BUTTONS[i]]:GetPoint(1);
                _G[MICRO_BUTTONS[i]]:SetPoint("BOTTOMLEFT", relativeTo, "BOTTOMRIGHT", -2, 0);
            end
        end
    else
        MoveMicroButtons("BOTTOMLEFT", MainMenuBarArtFrame, "BOTTOMRIGHT", MainMenuBarArtFrameBackground.MicroButtonArt:GetWidth()*-1-(-2*#MICRO_BUTTONS)+zmbOffset, -7.5, false);

        MainMenuBarPerformanceBar:SetSize(zmbScale, 40);
        for i=1, #MICRO_BUTTONS do
            _G[MICRO_BUTTONS[i]]:SetSize(zmbScale, 36);
            _G[MICRO_BUTTONS[i].."Flash"]:SetSize(zmbScale+5, 40);
            if i ~= 1 then
                local relativeTo;
                _, relativeTo = _G[MICRO_BUTTONS[i]]:GetPoint(1);
                _G[MICRO_BUTTONS[i]]:SetPoint("BOTTOMLEFT", relativeTo, "BOTTOMRIGHT", 0, 0);
            end
        end
    end
end

MainMenuBar:HookScript("OnShow", FloRetroUI_MainMenuBar_OnShow);

-- Move the right bar toward the bottom
hooksecurefunc("MultiActionBar_Update", function()
    if InCombatLockdown() then return end
    if ( SHOW_MULTI_ACTIONBAR_3 ) then
		VerticalMultiBarsContainer:SetPoint("BOTTOMRIGHT", 0, MicroButtonAndBagsBar:GetTop() + 24);
    end
end);

-- pet bar 

	PetActionBarFrame:ClearAllPoints();
	PetActionBarFrame:SetPoint("BOTTOMLEFT", MainMenuBarArtFrame, "TOPLEFT", 0, 65);
	UIPARENT_MANAGED_FRAME_POSITIONS["StanceBarFrame"] = nil;
	StanceBarFrame:ClearAllPoints();
	StanceBarFrame:SetPoint("BOTTOMLEFT", MainMenuBarArtFrame, "TOPLEFT", 0, 65);




local sliderVOffset = 60;
local sliderHOffset = 0;

-- LEFT BAR END SLIDER
local leftEndA = CreateFrame("Slider", "LeftBarEnd", f, "OptionsSliderTemplate");
leftEndA:SetPoint("CENTER", 0+sliderHOffset, 200+sliderVOffset);
leftEndA:SetWidth(100);
leftEndA:SetHeight(20);
leftEndA:SetOrientation('HORIZONTAL')
leftEndA.tooltipText = 'Set Left Bar End Offset' --Creates a tooltip on mouseover.
getglobal(leftEndA:GetName() .. 'Low'):SetText('-400'); --Sets the left-side slider text (default is "Low").
getglobal(leftEndA:GetName() .. 'High'):SetText('400'); --Sets the right-side slider text (default is "High").
getglobal(leftEndA:GetName() .. 'Text'):SetText('Left Bar End Offset'); --Sets the "title" text (top-centre of slider).
leftEndA:SetMinMaxValues(-400, 400)
leftEndA.minValue, leftEndA.maxValue = leftEndA:GetMinMaxValues() 
leftEndA.textLow = leftEndA.minValue
leftEndA.textHigh = leftEndA.maxValue
leftEndA.text = name
leftEndA:SetValue(zleftEndOffset);
leftEndA:SetValueStep(1)
leftEndA:SetScript("OnValueChanged", function(self,event,arg1) 
	leftEndOffset = event;
		MainMenuBarArtFrame.LeftEndCap:SetPoint("BOTTOMRIGHT", MainMenuBarArtFrame, "BOTTOMLEFT", MainMenuBarArtFrame.LeftEndCap:GetWidth()*-1+leftEndOffset, -10);
 end);


-- RIGHT BAR END SLIDER
local rightEndA = CreateFrame("Slider", "RightBarEnd", f, "OptionsSliderTemplate");
rightEndA:SetPoint("CENTER", 0+sliderHOffset, 150+sliderVOffset);
rightEndA:SetWidth(100);
rightEndA:SetHeight(20);
rightEndA:SetOrientation('HORIZONTAL')
rightEndA.tooltipText = 'Set Right Bar End and Bags Offset' --Creates a tooltip on mouseover.
getglobal(rightEndA:GetName() .. 'Low'):SetText('-400'); --Sets the left-side slider text (default is "Low").
getglobal(rightEndA:GetName() .. 'High'):SetText('400'); --Sets the right-side slider text (default is "High").
getglobal(rightEndA:GetName() .. 'Text'):SetText('Right Bar End Offset'); --Sets the "title" text (top-centre of slider).
rightEndA:SetMinMaxValues(-400, 400)
rightEndA.minValue, rightEndA.maxValue = rightEndA:GetMinMaxValues() 
rightEndA.textLow = rightEndA.minValue
rightEndA.textHigh = rightEndA.maxValue
rightEndA.text = name
rightEndA:SetValue(zrightEndOffset);
rightEndA:SetValueStep(1)
rightEndA:SetScript("OnValueChanged", function(self,event,arg1) 
	rightEndOffset = event;
		        MainMenuBarArtFrame.RightEndCap:SetPoint("BOTTOMLEFT", MainMenuBarArtFrame, "BOTTOMRIGHT", MainMenuBarArtFrame.LeftEndCap:GetWidth()+rightEndOffset, -10);
 end);


-- ACTIONBAR SLIDER
local ab = CreateFrame("Slider", "ab", f, "OptionsSliderTemplate");
ab:SetPoint("CENTER", 0+sliderHOffset, 100+sliderVOffset);
ab:SetWidth(100);
ab:SetHeight(20);
ab:SetOrientation('HORIZONTAL')
ab.tooltipText = 'Set Main Bar Offset' --Creates a tooltip on mouseover.
getglobal(ab:GetName() .. 'Low'):SetText('-400'); --Sets the left-side slider text (default is "Low").
getglobal(ab:GetName() .. 'High'):SetText('400'); --Sets the right-side slider text (default is "High").
getglobal(ab:GetName() .. 'Text'):SetText('Main Bar Offset'); --Sets the "title" text (top-centre of slider).
ab:SetMinMaxValues(-400, 400)
ab.minValue, ab.maxValue = ab:GetMinMaxValues() 
ab.textLow = ab.minValue
ab.textHigh = ab.maxValue
ab.text = name
ab:SetValue(zactBarOffset);
ab:SetValueStep(1)
ab:SetScript("OnValueChanged", function(self,event,arg1) 
	actBarOffset = event;
	    MainMenuBarArtFrameBackground:SetPoint("BOTTOM", UIParent, "BOTTOM", -BAGS_WIDTH+(MainMenuBarArtFrame.LeftEndCap:GetWidth()/3)+actBarOffset, 1);
 end);

-- XP BAR SCALE SLIDER
local xp = CreateFrame("Slider", "xp", f, "OptionsSliderTemplate");
xp:SetPoint("CENTER", 0+sliderHOffset, 50+sliderVOffset);
xp:SetWidth(100);
xp:SetHeight(20);
xp:SetOrientation('HORIZONTAL')
xp.tooltipText = 'Set XP bar scale' --Creates a tooltip on mouseover.
getglobal(xp:GetName() .. 'Low'):SetText('-400'); --Sets the left-side slider text (default is "Low").
getglobal(xp:GetName() .. 'High'):SetText('400'); --Sets the right-side slider text (default is "High").
getglobal(xp:GetName() .. 'Text'):SetText('XP Bar Scale'); --Sets the "title" text (top-centre of slider).
xp:SetMinMaxValues(-400, 400)
xp.minValue, xp.maxValue = xp:GetMinMaxValues() 
xp.textLow = xp.minValue
xp.textHigh = xp.maxValue
xp.text = name
xp:SetValue(zbarScale);
xp:SetValueStep(1)
xp:SetScript("OnValueChanged", function(self,event,arg1) 
	barScale = event;
		if ( zisDouble ) then
			StatusTrackingBarManager:SetDoubleBarSize(zbar, zbarWidth + BAGS_WIDTH + leftEndWidth + barScale);
		else
			StatusTrackingBarManager:SetSingleBarSize(zbar, zbarWidth + BAGS_WIDTH + leftEndWidth + barScale);
	    end
end);

-- MICROBUTTON SLIDER
local mb = CreateFrame("Slider", "mb", f, "OptionsSliderTemplate");
mb:SetPoint("CENTER", 0+sliderHOffset, 0+sliderVOffset);
mb:SetWidth(100);
mb:SetHeight(20);
mb:SetOrientation('HORIZONTAL')
mb.tooltipText = 'Set Microbuttons Offset' --Creates a tooltip on mouseover.
getglobal(mb:GetName() .. 'Low'):SetText('-400'); --Sets the left-side slider text (default is "Low").
getglobal(mb:GetName() .. 'High'):SetText('400'); --Sets the right-side slider text (default is "High").
getglobal(mb:GetName() .. 'Text'):SetText('Microbutton Offset'); --Sets the "title" text (top-centre of slider).
mb:SetMinMaxValues(-400, 400)
mb.minValue, mb.maxValue = mb:GetMinMaxValues() 
mb.textLow = mb.minValue
mb.textHigh = mb.maxValue
mb.text = name
mb:SetValue(zmbOffset);
mb:SetValueStep(1)
mb:SetScript("OnValueChanged", function(self,event,arg1) 
	mbOffset = event;
	zmbOffset = event;
		FloRetroUI_MainMenuBar_OnShow();
 end);
-- MICROBUTTONS SCALE SLIDER
local mbSc = CreateFrame("Slider", "mbSc", f, "OptionsSliderTemplate");
mbSc:SetPoint("CENTER", 0+sliderHOffset, -50+sliderVOffset);
mbSc:SetWidth(100);
mbSc:SetHeight(20);
mbSc:SetOrientation('HORIZONTAL')
mbSc.tooltipText = 'Microbuttons Scale' --Creates a tooltip on mouseover.
getglobal(mbSc:GetName() .. 'Low'):SetText('1'); --Sets the left-side slider text (default is "Low").
getglobal(mbSc:GetName() .. 'High'):SetText('100'); --Sets the right-side slider text (default is "High").
getglobal(mbSc:GetName() .. 'Text'):SetText('Microbutton Scale'); --Sets the "title" text (top-centre of slider).
mbSc:SetMinMaxValues(1, 100)
mbSc.minValue, mbSc.maxValue = mbSc:GetMinMaxValues() 
mbSc.textLow = mbSc.minValue
mbSc.textHigh = mbSc.maxValue
mbSc.text = name
mbSc:SetValue(zmbScale);
mbSc:SetValueStep(0.1)
mbSc:SetScript("OnValueChanged", function(self,event,arg1) 
	mbScale = event;
	zmbScale = event;
	FloRetroUI_MainMenuBar_OnShow();

 end);

-- MICROBUTTONS BG ART SLIDER
local mbg = CreateFrame("Slider", "mbg", f, "OptionsSliderTemplate");
mbg:SetPoint("CENTER", 0+sliderHOffset, -100+sliderVOffset);
mbg:SetWidth(100);
mbg:SetHeight(20);
mbg:SetOrientation('HORIZONTAL')
mbg.tooltipText = 'Microbutton Background Offset' --Creates a tooltip on mouseover.
getglobal(mbg:GetName() .. 'Low'):SetText('-400'); --Sets the left-side slider text (default is "Low").
getglobal(mbg:GetName() .. 'High'):SetText('400'); --Sets the right-side slider text (default is "High").
getglobal(mbg:GetName() .. 'Text'):SetText('Microbutton Background Offset'); --Sets the "title" text (top-centre of slider).
mbg:SetMinMaxValues(-400, 400)
mbg.minValue, mbg.maxValue = mbg:GetMinMaxValues() 
mbg.textLow = mbg.minValue
mbg.textHigh = mbg.maxValue
mbg.text = name
mbg:SetValue(zmbgOffset);
mbg:SetValueStep(1)
mbg:SetScript("OnValueChanged", function(self,event,arg1) 
	mbgOffset = event;
	MainMenuBarArtFrameBackground.MicroButtonArt:SetPoint("BOTTOMRIGHT", MainMenuBarArtFrame, "BOTTOMRIGHT", 0+mbgOffset, -10);
 end);

-- MICROBUTTONS BG ART SCALE SLIDER
local mbgSc = CreateFrame("Slider", "mbgSc", f, "OptionsSliderTemplate");
mbgSc:SetPoint("CENTER", 0+sliderHOffset, -150+sliderVOffset);
mbgSc:SetWidth(100);
mbgSc:SetHeight(20);
mbgSc:SetOrientation('HORIZONTAL')
mbgSc.tooltipText = 'Microbutton Background Scale' --Creates a tooltip on mouseover.
getglobal(mbgSc:GetName() .. 'Low'):SetText('-400'); --Sets the left-side slider text (default is "Low").
getglobal(mbgSc:GetName() .. 'High'):SetText('400'); --Sets the right-side slider text (default is "High").
getglobal(mbgSc:GetName() .. 'Text'):SetText('Microbutton background Scale'); --Sets the "title" text (top-centre of slider).
mbgSc:SetMinMaxValues(-400, 400)
mbgSc.minValue, mbgSc.maxValue = mbgSc:GetMinMaxValues() 
mbgSc.textLow = mbgSc.minValue
mbgSc.textHigh = mbgSc.maxValue
mbgSc.text = name
mbgSc:SetValue(zmbgScale)
mbgSc:SetValueStep(1)
mbgSc:SetScript("OnValueChanged", function(self,event,arg1) 
	mbgScale = event;
	MainMenuBarArtFrameBackground.MicroButtonArt:SetSize(BAGS_WIDTH*2+mbgScale, 44);

 end);
 
 -- BOTTOMACTIONBAR SCALE
local bottomActionBarScale = CreateFrame("Slider", "bottomActionBarScale", f, "OptionsSliderTemplate");
bottomActionBarScale:SetPoint("CENTER", 0+sliderHOffset, -200+sliderVOffset);
bottomActionBarScale:SetWidth(100);
bottomActionBarScale:SetHeight(20);
bottomActionBarScale:SetOrientation('HORIZONTAL')
bottomActionBarScale.tooltipText = 'Bottom Actionbar Scale' --Creates a tooltip on mouseover.
getglobal(bottomActionBarScale:GetName() .. 'Low'):SetText('0.1'); --Sets the left-side slider text (default is "Low").
getglobal(bottomActionBarScale:GetName() .. 'High'):SetText('2'); --Sets the right-side slider text (default is "High").
getglobal(bottomActionBarScale:GetName() .. 'Text'):SetText('Bottom Actionbar Scale'); --Sets the "title" text (top-centre of slider).
bottomActionBarScale:SetMinMaxValues(0.1, 2)
bottomActionBarScale.minValue, bottomActionBarScale.maxValue = bottomActionBarScale:GetMinMaxValues() 
bottomActionBarScale.textLow = bottomActionBarScale.minValue
bottomActionBarScale.textHigh = bottomActionBarScale.maxValue
bottomActionBarScale.text = name
bottomActionBarScale:SetValue(1.1)
bottomActionBarScale:SetValueStep(0.01)
bottomActionBarScale:SetScript("OnValueChanged", function(self,event,arg1) 
	babScale = event;
		MultiBarBottomLeft:SetScale(babScale, 1.0);
		MultiBarBottomRight:SetScale(babScale, 1.0);
 end);
 
  -- BOTTOMACTIONBAR OFFSET
local babVOs = CreateFrame("Slider", "babVOs", f, "OptionsSliderTemplate");
babVOs:SetPoint("CENTER", 0+sliderHOffset, -250+sliderVOffset);
babVOs:SetWidth(100);
babVOs:SetHeight(20);
babVOs:SetOrientation('HORIZONTAL')
babVOs.tooltipText = 'Bottom Actionbar Vertical Offset' --Creates a tooltip on mouseover.
getglobal(babVOs:GetName() .. 'Low'):SetText('-400'); --Sets the left-side slider text (default is "Low").
getglobal(babVOs:GetName() .. 'High'):SetText('400'); --Sets the right-side slider text (default is "High").
getglobal(babVOs:GetName() .. 'Text'):SetText('Bottom Actionbar V Offset'); --Sets the "title" text (top-centre of slider).
babVOs:SetMinMaxValues(-400, 400)
babVOs.minValue, babVOs.maxValue = babVOs:GetMinMaxValues() 
babVOs.textLow = babVOs.minValue
babVOs.textHigh = babVOs.maxValue
babVOs.text = name
babVOs:SetValue(zbabVOffset)
babVOs:SetValueStep(0.01)
babVOs:SetScript("OnValueChanged", function(self,event,arg1) 
	babVOffset = event;
	MultiBarBottomLeft:SetPoint("BOTTOMLEFT", ActionButton1, "TOPLEFT", 0, 30+babVOffset);
 end);

local name = "forceUICB"
local template = "UICheckButtonTemplate"
local checkButton = CreateFrame("CheckButton",name,f,template) --frameType, frameName, frameParent, frameTemplate    
checkButton:SetPoint("CENTER", 0+sliderHOffset, -300+sliderVOffset)
checkButton.text:SetText("Allow Taint")
checkButton.tooltipText = 'Enabling this option will allow taint'
checkButton:SetScript("OnClick", function(self,event,arg1)
  if checkButton:GetChecked() then
    	forceUI = true
  else
    	forceUI = false
  end
end)


local template = "UIPanelButtonTemplate"
local name = "HideBtn"
local hideBtn = CreateFrame("Button", name, f, template) --frameType, frameName, frameParent, frameTemplate    
hideBtn:SetSize(20,20)
hideBtn:SetPoint("TOPRIGHT",0,0)
hideBtn:SetText("X");
hideBtn:SetScript("OnClick", function(self, arg1)
    f:Hide();
end);

local rsetBtn = CreateFrame("Button", name, f, template) --frameType, frameName, frameParent, frameTemplate    
rsetBtn:SetSize(100,40)
rsetBtn:SetPoint("BOTTOMRIGHT",-5,5)
rsetBtn:SetText("RESET");
rsetBtn:SetScript("OnClick", function(self, arg1)
	bottomActionBarScale:SetValue(1.10);
	babVOs:SetValue(0);
    leftEndA:SetValue(0);
	rightEndA:SetValue(0);
	ab:SetValue(0);
	xp:SetValue(0);
	mbSc:SetValue(30);
	mbg:SetValue(0);
	mbgSc:SetValue(0);
	mb:SetValue(0);

end);

function setUI() 
	MainMenuBarArtFrameBackground.MicroButtonArt:SetSize(BAGS_WIDTH*2+zmbgScale, 44);
	MainMenuBarArtFrameBackground.MicroButtonArt:SetPoint("BOTTOMRIGHT", MainMenuBarArtFrame, "BOTTOMRIGHT", 0+zmbgOffset, -10);
	FloRetroUI_MainMenuBar_OnShow()
	leftEndA:SetValue(zleftEndOffset);
	rightEndA:SetValue(zrightEndOffset);
	mb:SetValue(zmbOffset);
	ab:SetValue(zactBarOffset);
	xp:SetValue(zbarScale);
	mbSc:SetValue(zmbScale);
	mbg:SetValue(zmbgOffset);
	mbgSc:SetValue(zmbgScale)
	babVOs:SetValue(zbabVOffset)
end

SLASH_UI1 = "/ui";

SlashCmdList["UI"] = function(msg)
	if(f:IsShown()) then
		f:Hide();
	else
		if InCombatLockdown() then
			print("Cannot show options during combat");
			return 
		end
		checkButton:SetChecked(forceUI);
		f:Show();
	end
end